declare namespace PROAPI {
    type ColumnTypePro<RecordType = unknown> = (ColumnGroupType<RecordType> | ColumnType<RecordType>) & { label: string };
    type ColumnsTypePro<RecordType = unknown> = ColumnTypePro[];
    type TableProProps<RecordType = unknown> = TableProps<RecordType> & {
        configName: string;
        config: any;
        fixed?: {
            left: number,
            right: number
        };
        title?: string;
        tips?: JSX.Element; // 提示
        czChild?: JSX.Element;
        leftChild?: JSX.Element;
        ajax?: any;//接口刷新
        size?: 'small' | 'middle' | 'large',
        className?: string,//自定义class
        total?: number;
        page?: number,
        pageSize?: number,
        scroll?: ({
            x?: string | number | true | undefined;
            y?: string | number | undefined;
        } & {
            scrollToFirstRowOnChange?: boolean | undefined;
        }),
        dataSource?: readonly any[]
        isZj?: boolean,//是否查总计
        totalData?: any[]
        refreshAjax?: () => void
    };
    type State = {
        columns: any[];
        configObj: { [key: string]: ColumnTypePro<any>; };
        defaultColumns: any[];
    };
    type HeaderContentProps = {
        isFullscreen: boolean;
        setIsFullscreen: React.Dispatch<React.SetStateAction<boolean>>;
        isFull: boolean;
        toggleFull: () => void;
        setVisible: React.Dispatch<React.SetStateAction<boolean>>;
        
    };
    type TableContentProps = {
        total?: number;
        page?: number;
        pageSize?: number;
        onPaginationChange?: (page: number, pageSize?: number) => void,
        handelResize?: (columns: any) => void
    }
}