import { Badge } from "antd";
import React from "react";

/**广告状态 */
export const GGStateData = {
    'STATUS_PENDING': '审核中',
    'STATUS_DENIED': <Badge status="error" text={<span style={{ fontSize: 12 }}>审核不通过</span>}/>,
    'STATUS_SUSPEND': <Badge status="warning" text={<span style={{ fontSize: 12 }}>暂停中</span>}/>,
    'STATUS_READY': <Badge status="default" text={<span style={{ fontSize: 12 }}>未到投放时间</span>}/>,
    'STATUS_ACTIVE': <Badge status="processing" text={<span style={{ fontSize: 12 }}>投放中</span>}/>,
    'STATUS_STOP': '投放结束',
    'STATUS_ACTIVE_CAMPAIGN_SUSPEND': '广告被暂停',
    'STATUS_PART_READY': '部分待投放',
    'STATUS_PART_ACTIVE': '部分投放中',
    'STATUS_DELETED': <Badge status="error" text={<span style={{ fontSize: 12 }}>已删除</span>}/>,
    'STATUS_UNKNOWN': '未知状态',
    'STATUS_FROZEN': '冻结',
    'STATUS_PREPARE': '准备中'
}

/** 广告状态 */
export const ADGROUP_STATUS = {
    'ADGROUP_STATUS_FROZEN': <Badge status="warning" text={<span style={{ fontSize: 12 }}>已冻结</span>}/>,
    'ADGROUP_STATUS_SUSPEND': <Badge status="warning" text={<span style={{ fontSize: 12 }}>暂停中</span>}/>,
    'ADGROUP_STATUS_NOT_IN_DELIVERY_TIME': <Badge status="default" text={<span style={{ fontSize: 12 }}>未到投放时间</span>}/>,
    'ADGROUP_STATUS_ACTIVE': <Badge status="processing" text={<span style={{ fontSize: 12 }}>投放中</span>}/>,
    'ADGROUP_STATUS_DELETED': <Badge status="error" text={<span style={{ fontSize: 12 }}>已删除</span>}/>,
    'ADGROUP_STATUS_ACCOUNT_BALANCE_NOT_ENOUGH': <Badge status="warning" text={<span style={{ fontSize: 12 }}>账户余额不足</span>}/>,
    'ADGROUP_STATUS_DAILY_BUDGET_REACHED': <Badge status="warning" text={<span style={{ fontSize: 12 }}>广告达到日预算上限</span>}/>,
    'ADGROUP_STATUS_PARTIAL_ACTIVE': <Badge status="warning" text={<span style={{ fontSize: 12 }}>部分投放中</span>}/>,
    'ADGROUP_STATUS_CREATIVE_STATUS_PENDING': <Badge status="warning" text={<span style={{ fontSize: 12 }}>创意未投放</span>}/>,
    'ADGROUP_STATUS_CREATIVE_EMPTY': <Badge status="warning" text={<span style={{ fontSize: 12 }}>创意准备中</span>}/>,
    'ADGROUP_STATUS_JOINT_BUDGET_REACHED': <Badge status="warning" text={<span style={{ fontSize: 12 }}>广告被暂停</span>}/>,
    'ADGROUP_STATUS_TOTAL_BUDGET_REACHED': <Badge status="warning" text={<span style={{ fontSize: 12 }}>广告达到总预算上限</span>}/>,
}