import { EditOutlined } from "@ant-design/icons"
import { Button, Col, Row } from "antd"
import React from "react"

// 变更记录
const columnsCrGdt = (editHandle: (data: any) => void) => {
    return [
        {
            title: '开始时间',
            dataIndex: 'beginTime',
            key: 'beginTime',
            align: 'center',
            width: 140,
            fixed: 'left',
        },
        {
            title: '结束时间',
            dataIndex: 'endTime',
            key: 'endTime',
            align: 'center',
            fixed: 'left',
            width: 140
        },
        {
            title: '操作人',
            dataIndex: 'createName',
            key: 'createName',
            align: 'center',
            width: 80,
            ellipsis: true,
            render: (a: any) => {
                return <span>{a || '<空>'}</span>
            }
        },
        {
            title: '资源名称',
            dataIndex: 'putResourceName',
            key: 'putResourceName',
            width: 140,
            ellipsis: true,
            align: 'center',
            render: (a: any, b: any) => {
                return <span>{a || '<空>'}</span>
            }
        },
        {
            title: '资源标识',
            dataIndex: 'putResourceKey',
            key: 'putResourceKey',
            ellipsis: true,
            width: 180,
            render: (a: any, b: any) => {
                return <span>{a || '<空>'}</span>
            }
        },
        {
            title: '授权者',
            dataIndex: 'putUserName',
            key: 'putUserName',
            ellipsis: true,
            width: 80
        },
        {
            title: '操作',
            dataIndex: 'cz',
            key: 'cz',
            render: (a: string, b: any) => (
                <Row gutter={[10, 0]}>
                    <Col><Button type="link" size="small" style={{ fontSize: 12 }} icon={<EditOutlined />} onClick={() => { editHandle(b) }}>编辑</Button></Col>
                </Row>
            )
        }
    ]
}

export {
    columnsCrGdt
}