import { AdcreativeTemplateEnum, LinkPageNameTypeEnum, LinkPageTypeEnum, PromotedObjectType } from '@/services/launchAdq/enum'
import { copy } from '@/utils/utils'
import { CopyOutlined } from '@ant-design/icons'
import { Space } from 'antd'
import React from 'react'
function tableConfig(tableIdClick: (props: {
    activeKey: string,
    parma: {
        accountId?: string,//账户ID
        campaignId?: string,//计划ID
        adgroupId?: string,//广告ID
        adcreativeId?: string,//创意ID
        pageId?: string,//落地页ID
        targetingId?: string,//定向ID
    }
}) => void): any {
    return [
        {
            title: '所属账号',
            dataIndex: 'accountId',
            key: 'accountId',
            align: 'center',
            width: 100,
            ellipsis: true,
            render: (a: string) => {
                return <Space>
                     <a onClick={() => copy(a)} >{a}</a>
                </Space>
            }
        },
        {
            title: '创意ID',
            dataIndex: 'adcreativeId',
            key: 'adcreativeId',
            align: 'center',
            width: 120,
            ellipsis: true,
            render: (a: string) => {
                return <Space>
                   <a onClick={() => copy(a)} >{a}</a>
                </Space>
            }
        },
        {
            title: '所属计划ID',
            dataIndex: 'campaignId',
            key: 'campaignId',
            align: 'center',
            width: 120,
            ellipsis: true,
            render: (a: string) => {
                return <Space>
                    <a onClick={() => copy(a)} >{a}</a>
                </Space>
            }
        },
        // {
        //     title: '附加创意组件ID',
        //     dataIndex: 'componentId',
        //     key: 'componentId',
        //     align: 'center',
        //     width: 120
        // },
        // {
        //     title: '互动推广页落地页ID',
        //     dataIndex: 'playablePageMaterialId',
        //     key: 'playablePageMaterialId',
        //     align: 'center',
        //     width: 140
        // },
        // {
        //     title: '朋友圈头像昵称跳转页ID',
        //     dataIndex: 'profileId',
        //     key: 'profileId',
        //     align: 'center',
        //     width: 170
        // },
        {
            title: '创意名称',
            dataIndex: 'adcreativeName',
            key: 'adcreativeName',
            width: 350,
            align: 'center',
        },
        // {
        //     title: '创意形式类型',
        //     dataIndex: 'creativeTemplateCategory',
        //     key: 'creativeTemplateCategory',
        //     align: 'center',
        // },
        // {
        //     title: 'QQ小游戏监控参数',
        //     dataIndex: 'qqMiniGameTrackingQueryString',
        //     key: 'qqMiniGameTrackingQueryString',
        //     align: 'center',
        // },
        {
            title: '推广目标类型',
            dataIndex: 'promotedObjectType',
            key: 'promotedObjectType',
            align: 'center',
            render: (a: string | number) => {
                return PromotedObjectType[a]
            }
        },
        // {
        //     title: '推广目标ID',
        //     dataIndex: 'promotedObjectId',
        //     key: 'promotedObjectId',
        //     align: 'center',
        // },
        // {
        //     title: '落地页类型',
        //     dataIndex: 'pageType',
        //     key: 'pageType',
        //     align: 'center',
        //     render: (a: string) => {
        //         return PageTypeEnum[a]
        //     }
        // },
        // {
        //     title: '互动推广页落地页 id',
        //     dataIndex: 'playablePageMaterialId',
        //     key: 'playablePageMaterialId',
        //     align: 'center',
        //     // render: (a: string) => {
        //     //     return PageTypeEnum[a]
        //     // }
        // },
        // {
        //     title: '简版原生页子类型',
        //     dataIndex: 'simpleCanvasSubType',
        //     key: 'simpleCanvasSubType',
        //     align: 'center',
        //     // render: (a: string) => {
        //     //     return PageTypeEnum[a]
        //     // }
        // },
        // {
        //     title: '创意来源',
        //     dataIndex: 'source',
        //     key: 'source',
        //     align: 'center',
        //     // render: (a: string) => {
        //     //     return SourceEnum[a]
        //     // }
        // },
        // {
        //     title: '数据版本类型',
        //     dataIndex: 'creativeTemplateVersionType',
        //     key: 'creativeTemplateVersionType',
        //     align: 'center',
        //     // render: (a: string) => {
        //     //     return CreativeTemplateVersionTypeEnum[a]
        //     // }
        // },
        // {
        //     title: '是否支持版位突破',
        //     dataIndex: 'enableBreakthroughSiteset',
        //     key: 'enableBreakthroughSiteset',
        //     align: 'center',
        //     render: (a: any, b: any) => {
        //         return a? '是' : '否'
        //     }
        //     // render: (a: string) => {
        //     //     return PageTypeEnum[a]
        //     // }
        // },
        // {
        //     title: '应用直达页URL',
        //     dataIndex: 'deepLinkUrl',
        //     key: 'deepLinkUrl',
        //     align: 'center',
        // },
        // {
        //     title: '通用链接页URL',
        //     dataIndex: 'universalLinkUrl',
        //     key: 'universalLinkUrl',
        //     align: 'center',
        // },
        // {
        //     title: '简易原生页嵌入',
        //     dataIndex: 'webviewUrl',
        //     key: 'webviewUrl',
        //     align: 'center',
        // },
        // {
        //     title: '头像点击跳转信息',
        //     dataIndex: 'headClickType',
        //     key: 'headClickType',
        //     align: 'center',
        //     render: (a: string) => {
        //         return HeadClickTypeEnum[a]
        //     }
        // },
        // {
        //     title: '链接名称类型',
        //     dataIndex: 'linkNameType',
        //     key: 'linkNameType',
        //     align: 'center',
        //     render: (a: string) => {
        //         return LinkPageNameTypeEnum[a]
        //     }
        // },
        {
            title: '跳转落地页类型',
            dataIndex: 'linkPageType',
            key: 'linkPageType',
            align: 'center',
            render: (a: string) => {
                return LinkPageTypeEnum[a]
            }
        },
        // {
        //     title: '挂件图',
        //     dataIndex: 'marketingPendantImageId',
        //     key: 'marketingPendantImageId',
        //     align: 'center'
        // },
        // {
        //     title: '页面级转化跟踪URL',
        //     dataIndex: 'pageTrackUrl',
        //     key: 'pageTrackUrl',
        //     align: 'center'
        // },
        // {
        //     title: '页面级转化跟踪URL',
        //     dataIndex: 'pageTrackUrl',
        //     key: 'pageTrackUrl',
        //     align: 'center'
        // },
        {
            title: '创意形式',
            dataIndex: 'adcreativeTemplateId',
            key: 'adcreativeTemplateId',
            align: 'center',
            render: (a: string | number) => {
                return AdcreativeTemplateEnum[a]
            }
        },
        // {
        //     title: '是否开启自动版位功能',
        //     dataIndex: 'automaticSiteEnabled',
        //     key: 'automaticSiteEnabled',
        //     align: 'center',
        //     render: (a: any, b: any) => {
        //         return a? '开' : '关'
        //     }
        // },
        // {
        //     title: '数据展示',
        //     dataIndex: 'conversionDataType',
        //     key: 'conversionDataType',
        //     align: 'center',
        //     render: (a: any, b: any) => {
        //         return b.conversionDataType || b.conversionTargetType ? '开' : '关'
        //     }
        // },
        {
            title: '行动开关',
            dataIndex: 'linkNameType',
            key: 'linkNameType',
            align: 'center',
            render: (a: any, b: any) => {
                return b.linkNameType || b.linkPageType ? <div>
                    {b.linkNameType && <div><span style={{ color: "#5a5a5a" }}>{LinkPageNameTypeEnum[b.linkNameType]}</span></div>}
                    {b.linkPageType && <div><span style={{ color: "#5a5a5a" }}>{LinkPageTypeEnum[b.linkPageType]}</span></div>}
                </div> : '关'
            }
        },
        // {
        //     title: '倒计时组件开关',
        //     dataIndex: 'countdownSwitch',
        //     key: 'countdownSwitch',
        //     align: 'center',
        //     render: (a: any, b: any) => {
        //         return a? '开' : '关'
        //     }
        // },
        // {
        //     title: '视频广告评论开关',
        //     dataIndex: 'feedsVideoCommentSwitch',
        //     key: 'feedsVideoCommentSwitch',
        //     align: 'center',
        //     render: (a: any, b: any) => {
        //         return a? '开' : '关'
        //     }
        // },
        // {
        //     title: '是否已删除',
        //     dataIndex: 'isDeleted',
        //     key: 'isDeleted',
        //     align: 'center',
        //     render: (a: any, b: any) => {
        //         return a? '是' : '否'
        //     }
        // },
        // {
        //     title: '动态创意广告自动生成',
        //     dataIndex: 'isDynamicCreative',
        //     key: 'isDynamicCreative',
        //     align: 'center',
        //     render: (a: any, b: any) => {
        //         return a? '是' : '否'
        //     }
        // },
        {
            title: '创建时间',
            dataIndex: 'createdTime',
            key: 'createdTime',
            align: 'center',
            width: 150
        },
    ]
}
export default tableConfig