import { AdcreativeTemplateEnum, LinkPageNameTypeEnum, LinkPageTypeEnum, PageTypeEnum, PromotedObjectType } from '@/services/launchAdq/enum'
import React from 'react'
function tableConfig(): any {
    return [
        {
            title: 'ID',
            dataIndex: 'id',
            key: 'id',
            align: 'center',
            width: 50
        },
        {
            title: '创意名称',
            dataIndex: 'adcreativeName',
            key: 'adcreativeName',
            width: 160,
            ellipsis: true
        },
        {
            title: '推广目标',
            dataIndex: 'promotedObjectType',
            key: 'promotedObjectType',
            align: 'center',
            render: (a: string | number) => {
                return PromotedObjectType[a]
            }
        },
        {
            title: '落地页类型',
            dataIndex: 'pageType',
            key: 'pageType',
            align: 'center',
            width: 120,
            render: (a: string) => {
                return PageTypeEnum[a]
            }
        },
        {
            title: '创意形式',
            dataIndex: 'adcreativeTemplateId',
            key: 'adcreativeTemplateId',
            align: 'center',
            render: (a: any) => {
                return AdcreativeTemplateEnum[a]
            }
        },
        {
            title: '数据展示',
            dataIndex: 'conversionDataType',
            key: 'conversionDataType',
            align: 'center',
            render: (a: any, b: any) => {
                return b.conversionDataType || b.conversionTargetType ? '开' : '关'
            }
        },
        {
            title: '行动开关',
            dataIndex: 'linkNameType',
            key: 'linkNameType',
            align: 'center',
            render: (a: any, b: any) => {
                return b.linkNameType || b.linkPageType ? <div>
                    {b.linkNameType && <div><span style={{ color: "#5a5a5a" }}>{LinkPageNameTypeEnum[b.linkNameType]}</span></div>}
                    {b.linkPageType && <div><span style={{ color: "#5a5a5a" }}>{LinkPageTypeEnum[b.linkPageType]}</span></div>}
                </div> : '关'
            }
        },
        {
            title: '创建时间',
            dataIndex: 'createTime',
            key: 'createTime',
            align: 'center',
            width: 140
        }
    ]
}
export default tableConfig