import React from 'react';
import { Typography } from 'antd';
import { HOUR_LIST } from './const';

import './header.less';

const Header: React.FC = () => {
    return (
        <div className="table_header_wrapper">
            <div className="left">
                <Typography.Text>星期 \ 时间</Typography.Text>
            </div>
            <div className="right">
                <div className="top">
                    <div className="before">00:00 - 12:00</div>
                    <div className="after">12:00 - 24:00</div>
                </div>
                <div className="foot">
                    {HOUR_LIST.map((item, index) => (
                        <Typography key={index}>{item}</Typography>
                    ))}
                </div>
            </div>
        </div>
    );
}
export default React.memo(Header)