import { PageTypeEnum, PromotedObjectType } from '@/services/launchAdq/enum'
import React from 'react'
import { Space } from 'antd'
function tableConfig(callback:(data:any,type:'edit'|'look')=>void): any {
    return [
        {
            title: 'ID',
            dataIndex: 'id',
            key: 'id',
            align: 'center',
            width: 70
        },
        {
            title: '创意名称',
            dataIndex: 'adcreativeName',
            key: 'adcreativeName',
            align: 'center',
        },
        {
            title: '广告推广目标类型',
            dataIndex: 'promotedObjectType',
            key: 'promotedObjectType',
            align: 'center',
            render: (a: string | number) => {
                return PromotedObjectType[a]
            }
        },
        {
            title: '落地页类型',
            dataIndex: 'pageType',
            key: 'pageType',
            align: 'center',
            render: (a: string) => {
                return PageTypeEnum[a]
            }
        },
        {
            title: '创意形式ID',
            dataIndex: 'adcreativeTemplateId',
            key: 'adcreativeTemplateId',
            align: 'center',
        },
        {
            title: '数据展示',
            dataIndex: 'conversionDataType',
            key: 'conversionDataType',
            align: 'center',
            render: (a: any, b: any) => {
                return b.conversionDataType || b.conversionTargetType ? '开' : '关'
            }
        },
        {
            title: '行动开关',
            dataIndex: 'linkNameType',
            key: 'linkNameType',
            align: 'center',
            render: (a: any, b: any) => {
                return b.linkNameType || b.linkPageType ? '开' : '关'
            }
        },
        {
            title: '创建时间',
            dataIndex: 'createTime',
            key: 'createTime',
            align: 'center',
        },
        {
            title: '操作',
            dataIndex: 'cz',
            key: 'cz',
            align: 'center',
            render:(a: any,b: any)=>{
                return <Space>
                     <a onClick={()=>{
                         callback(b,'look')
                     }}>详情</a>
                 </Space>
             }
        }
    ]
}
export default tableConfig