import { Tabs } from 'antd';
import React from 'react';
import AstraSupport from './astraSupport‌';
import AstraGroup from './astraGroup';

/**
 * 企微客服组监控
 * @returns 
 */
const MonitorEWList: React.FC = () => {

    const [currentTab, setCurrentTab] = React.useState<string>('hao');

    return <Tabs
        type="card"
        activeKey={currentTab}
        onChange={(key) => setCurrentTab(key)}
        tabBarStyle={{ marginBottom: 2 }}
        items={[
            { 
                label: '客服号加粉数据', 
                key: 'hao', 
                children: <>
                    {currentTab === 'hao' && <AstraSupport />}
                </> 
            },
            { 
                label: '客服组加粉数据', 
                key: 'zu', 
                children: <>
                    {currentTab === 'zu' && <AstraGroup />}
                </>
            }
        ]}
    />
};

export default MonitorEWList;