import { Button, Space, TableProps } from "antd"
import React from "react"
import { EditOutlined } from "@ant-design/icons"
import GroupUserInfo from "./groupUserInfo"

const columns = (handleEdit: (data: any) => void): TableProps<any>['columns'] => {

    return [
        {
            title: '客服组名称',
            dataIndex: 'csgroupName',
            key: 'csgroupName',
            width: 280,
            fixed: 'left',
            render(value, records) {
                return <span style={{ fontSize: 12 }}>{value}（ID：{records.id}）</span>
            }
        },
        {
            title: '媒体账户',
            dataIndex: 'accountId',
            key: 'accountId',
            width: 80,
            render(value, records) {
                return <span style={{ fontSize: 12 }}>{value}</span>
            }
        },
        {
            title: '是否组集',
            dataIndex: 'type',
            key: 'type',
            width: 80,
            align: 'center',
            render(value) {
                return <span style={{ fontSize: 12 }}>{value == 1 ? '否' : '是'}</span>
            }
        },
        {
            title: '归属组集',
            dataIndex: 'parentName',
            key: 'parentName',
            width: 100,
            align: 'center',
            render(value) {
                return <span style={{ fontSize: 12 }}>{value || '--'}</span>
            }
        },

        {
            title: '企业名称',
            dataIndex: 'tencentCorpName',
            key: 'tencentCorpName',
            width: 110,
            align: 'center',
            ellipsis: true,
            render(value) {
                return <span style={{ fontSize: 12 }}>{value}</span>
            }
        },
        {
            title: '企业ID',
            dataIndex: 'tencentCorpId',
            key: 'tencentCorpId',
            width: 280,
            render(value) {
                return <span style={{ fontSize: 12 }}>{value}</span>
            }
        },
        {
            title: '切号策略',
            dataIndex: 'policyName',
            key: 'policyName',
            width: 100,
            align: 'center',
            render(value) {
                return <span style={{ fontSize: 12 }}>{value}</span>
            }
        },
        {
            title: '创建时间',
            dataIndex: 'createTime',
            key: 'createTime',
            width: 150,
            render(value) {
                return <span style={{ fontSize: 12 }}>{value}</span>
            }
        },
        {
            title: '更新时间',
            dataIndex: 'updateTime',
            key: 'updateTime',
            width: 150,
            render(value) {
                return <span style={{ fontSize: 12 }}>{value}</span>
            }
        },
        {
            title: '操作',
            dataIndex: 'cz',
            key: 'cz',
            width: 200,
            fixed: 'right',
            render(_, record) {
                return <Space>
                    {/* <UserInfo userInfoList={record.userInfoList} createTime={record.createTime} groupMemberCnt={record.groupMemberCnt} /> */}
                    {record.type == 1 && <GroupUserInfo adAccountId={record.accountId} groupData={record} />} 
                    <Button icon={<EditOutlined />} style={{ border: 'none', fontSize: 12 }} size='small' onClick={() => handleEdit(record)}>修改</Button>
                </Space>
            }
        }
    ]
}
export default columns