import React from "react"
import style from './index.less'
import { CheckCircleFilled } from "@ant-design/icons"

/**
 * 营销目的
 * @param param0 
 * @returns 
 */
const MarketingGoal: React.FC<PULLIN.FormItemDataProps> = ({ data, value, onChange, id }) => {


    return <div className={style.marketingGoal} id={id}>
        <div className={style.marketingGoal_row}>
            {data.map(item => <div key={item.value} onClick={() => onChange?.(item.value)} className={`${style.marketingGoal_col} ${value === item.value ? style.marketingGoal_active : ''}`}>
                {value === item.value ? <>
                    <img src={item.iconSelected} />
                    <div><CheckCircleFilled /></div>
                </> : <img src={item.icon} />}
                <span>{item.label}</span>
            </div>)}
        </div>
    </div>
}

export default React.memo(MarketingGoal)